/* R-U-ON Vista Gadget           */
/* Copyright (c) 2007 R-U-ON LLC */
/* www.r-u-on.com                */

// name, show field name, nowrap
var detailFields = {
    "alarms":[  ["Agent", false, false], ["Resource", true, false],
            ["Time Up", false, true],null,["Description", false, false],null
            ],
    "agents":[
            ["Agent", true, false],["Type", true, true],["State", true, true],
            ["Severity", true, true],["IP", true, true],["Public IP", true, true],
            ["OS", true, true],["Group", true, true],["Last contact", true, true],
            ["Uptime", true, true]
            ],
    "tickets":[
            ["TRK#", true, true], ["Title", false, false],null, ["Opened By", true, true],
            ["Opened At", true, true], ["Status", true, true], ["Severity", true, true],
            ["Assigned To", true, true], ["Category", true, true]
            ]
};

var detailAliases = {};

var bodySize = {
    "alarms": {"width":230,"height":170},
    "agents": {"width":230,"height":220},
    "tickets": {"width":230,"height":220}
};
var detailTitle = {
    "alarms":"Alarm Details",
    "agents":"Agent Details",
    "tickets":"Ticket Details"
};


function flyout(mode, data) {
    System.Gadget.Flyout.file = "flyout.html";
    System.Gadget.Flyout.show = true;
    System.Gadget.Flyout.document.mode = mode;
    System.Gadget.Flyout.document.data = data;
}

function close() {
    System.Gadget.Flyout.show = false;
}

function flyoutInit() {
    var mode = document.mode;
    var data = document.data;
    pageSize(bodySize[mode]["width"], bodySize[mode]["height"]);

    flyoutinfo.innerHTML = detailHtml(data, detailFields[mode]);
    title.innerHTML = detailTitle[mode];
    document.body.focus();
}

function detailHtml(record, meta) {
    var html="<br>";
    for (var i=0;i<meta.length;++i) {
        if (meta[i]==null) {
            html+="<br>";
            continue;
        }
        var value = record[meta[i][0]];
        if (value==null) {
            value = "";
        }
        value = value.replace(/\n/g, "<br>");

        if (meta[i][2]) { // nowrap
            html+='<span style="white-space: nowrap;">';
        }
        if (meta[i][1]) {
            var alias = detailAliases[meta[i][0]];
            html+='<span class="detailshead">'+(alias!=null?alias:meta[i][0])+": </span>";
        }

        html+=value;
        if (meta[i][2]) { // nowrap
            html+="</span>";
        }
        html+="<br>";
    }
    html+="<br><a href=\""+record["link"]+"\">More...</a>";
    return html;
}

